#include <iostream>
#include <exception>
using namespace std;

class list {
	struct elem{
		int data_;
		elem* next_;
		elem(int val=0) : data_(val), next_(NULL) {}
	};
	
	elem *head_;
	
	public:
		list(): head_(NULL){}
		
		bool empty() { 
			return head_==NULL;
		}
		
		void prepend(int val) {
			elem* new_elem=new elem(val);
			new_elem->next_=head_;
			head_=new_elem;
		}
		
		void del() {
			if(!empty()) {
				elem* to_del=head_;
				head_=head_->next_;
				delete to_del;
			}
		}
		
		void print() {
			elem* curr_elem=head_;
			while(curr_elem!=NULL) {
				cout << curr_elem->data_ << ", ";
				curr_elem=curr_elem->next_;	
			}
			cout << endl;
		}
		
		int first() {
			if(empty()) {
				cerr << "the list is empty..." << endl;
				throw exception();
			}	
			return head_->data_;
		}
		
		void release() {
			while(!emtpy()) 
				del();	
		}
};

int main(void) {
	list l1;
	l1.prepend(10);
	l1.prepend(20);
	l1.prepend(30);
	
	l1.print();
	
	cout<< "first is: " 
		<< l1.first() << endl;
	l1.del();
	cout<< "after del() first is: " 
		<< l1.first() << endl;
	
	return 0;		
}
